// named.var.client.c
// Copyright (c) 1999 Microsoft Corporation.  All rights reserved.
//

#include "gauges.h"
#include "named.var.client.h"

//	Set up import and export tables and gauge header
char    gauge_name[]            = "named.var.client\0";
extern	PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 100, gauge_name, &list );


FAILURE_RECORD	fail[] =
{
	{FAIL_NONE, FAIL_ACTION_NONE}
};

MAKE_STATIC(	background,
				BMP_BACKGROUND,
				NULL,
				fail,
				IMAGE_USE_TRANSPARENCY,
				0,
				{0,0} )

PELEMENT_HEADER		list	= &background.header;

MOUSE_FUNCTION	decrement_var;
MOUSE_FUNCTION	increment_var;

MOUSE_BEGIN( mouse_rect, 0, 0, 0 )
	MOUSE_CHILD_FUNCT(0, 0, 50, 100, CURSOR_DOWNARROW, MOUSE_LEFTSINGLE, decrement_var)
	MOUSE_CHILD_FUNCT(50, 0, 50, 100, CURSOR_UPARROW, MOUSE_LEFTSINGLE, increment_var)
MOUSE_END

MODULE_VAR	var1;

BOOL	FSAPI	decrement_var (PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	PUINT32	pvar = (PUINT32)var1.var_ptr;

	if (pvar != NULL)
	{
		(*pvar)--;
	}

	return	TRUE;
}

BOOL	FSAPI	increment_var (PPIXPOINT relative_point, FLAGS32 mouse_flags)
{
	PUINT32	pvar = (PUINT32)var1.var_ptr;

	if (pvar != NULL)
	{
		(*pvar)++;
	}

	return	TRUE;
}


//---------------------------------------------------------------------------
void FSAPI		install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );
}


//---------------------------------------------------------------------------
void FSAPI		initialize_routine()
{
	element_list_initialize( list );
	initialize_var_by_name (&var1, "Named.Var.Server.Var1");
}


//---------------------------------------------------------------------------
void FSAPI		update_routine()
{
	element_list_update(list);
}

//---------------------------------------------------------------------------
void FSAPI		generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI		draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI		kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
}

