// named.var.server.c
// Copyright (c) 1999 Microsoft Corporation.  All rights reserved.
//

#include	"windows.h"
#include	"gauges.h"
#include	"named.var.server.h"

//	Set up import and export tables and gauge header
char    gauge_name[]            = "named.var.server\0";
extern	PELEMENT_HEADER		list;
MODULE_SETUP( GAUGE_HEADER_VERSION, 100, gauge_name, &list );

#define GAUGE_CHARSET						DEFAULT_CHARSET
#define GAUGE_FONT_DEFAULT					"Courier New"
#define GAUGE_WEIGHT_DEFAULT				FW_NORMAL

FN_FLOAT64	update_var1;

FAILURE_RECORD	fail[] =
{
	{FAIL_NONE, FAIL_ACTION_NONE}
};


MAKE_STRING(	var1_display,
				NULL,
				NULL,
				IMAGE_USE_ERASE | IMAGE_USE_BRIGHT,
				0,
				{20, 20},
				{60, 40},
				7,
				MODULE_VAR_NONE, NULL,
				MODULE_VAR_NONE, NULL,
				MODULE_VAR_NONE, NULL,
				update_var1,
				RGB(255,0,0),
				RGB(0,0,0),
				RGB(92,92,92),
				GAUGE_FONT_DEFAULT,
				GAUGE_WEIGHT_DEFAULT,
				GAUGE_CHARSET,
				NULL )

PELEMENT_HEADER	plist[] =
{
	&var1_display.header,
	NULL
};

MAKE_STATIC(	background,
				BMP_BACKGROUND,
				&plist,
				fail,
				IMAGE_USE_TRANSPARENCY,
				0,
				{0,0} )

PELEMENT_HEADER		list	= &background.header;

MOUSE_BEGIN( mouse_rect, 0, 0, 0 )
MOUSE_END

// vars made available to other gauges
UINT32		var1 = 0;

FLOAT64 FSAPI	update_var1( FLOAT64 val )
{
	val = (FLOAT64)var1;

	wsprintf(var1_display.string, "%7d", (UINT32)val);

	return val;
}

//---------------------------------------------------------------------------
void FSAPI		install_routine( HINSTANCE resource_file_handle )
{
	element_list_install( list, resource_file_handle );
	mouse_list_install( mouse_rect, &gauge_header, &background.image_data.final->dim );
	mouse_list_register( mouse_rect, &gauge_header );

	register_var_by_name (&var1, TYPE_UINT32, "Named.Var.Server.Var1");
}


//---------------------------------------------------------------------------
void FSAPI		initialize_routine()
{
	element_list_initialize( list );
}


//---------------------------------------------------------------------------
void FSAPI		update_routine()
{
	element_list_update(list);
}

//---------------------------------------------------------------------------
void FSAPI		generate_routine( GENERATE_PHASE phase )
{
	element_list_generate( list, phase );
}


//---------------------------------------------------------------------------
void FSAPI		draw_routine()
{
	element_list_plot( list );
}


//---------------------------------------------------------------------------
void FSAPI		kill_routine()
{
	mouse_list_unregister( mouse_rect, &gauge_header );
	element_list_kill( list );
	unregister_var_by_name ("Named.Var.Server.Var1");
}

